/*
 * Copyright 2010 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * This code was generated by https://github.com/google/apis-client-generator/
 * (build: 1969-12-31 23:59:59 UTC)
 * on 2021-02-24 at 00:14:02 UTC 
 * Modify at your own risk.
 */

package com.google.api.services.mybusiness.v4.model;

/**
 * Serving portion size of a food dish.
 *
 * <p> This is the Java data model class that specifies how to parse/serialize into the JSON that is
 * transmitted over HTTP when working with the Google My Business API. For a detailed explanation
 * see:
 * <a href="https://developers.google.com/api-client-library/java/google-http-java-client/json">https://developers.google.com/api-client-library/java/google-http-java-client/json</a>
 * </p>
 *
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public final class PortionSize extends com.google.api.client.json.GenericJson {

  /**
   * Required. Number of the portion.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.Integer quantity;

  /**
   * Required. The repeated name_info field is for the unit in multiple languages.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.util.List<MenuLabel> unit;

  static {
    // hack to force ProGuard to consider MenuLabel used, since otherwise it would be stripped out
    // see https://github.com/google/google-api-java-client/issues/543
    com.google.api.client.util.Data.nullOf(MenuLabel.class);
  }

  /**
   * Required. Number of the portion.
   * @return value or {@code null} for none
   */
  public java.lang.Integer getQuantity() {
    return quantity;
  }

  /**
   * Required. Number of the portion.
   * @param quantity quantity or {@code null} for none
   */
  public PortionSize setQuantity(java.lang.Integer quantity) {
    this.quantity = quantity;
    return this;
  }

  /**
   * Required. The repeated name_info field is for the unit in multiple languages.
   * @return value or {@code null} for none
   */
  public java.util.List<MenuLabel> getUnit() {
    return unit;
  }

  /**
   * Required. The repeated name_info field is for the unit in multiple languages.
   * @param unit unit or {@code null} for none
   */
  public PortionSize setUnit(java.util.List<MenuLabel> unit) {
    this.unit = unit;
    return this;
  }

  @Override
  public PortionSize set(String fieldName, Object value) {
    return (PortionSize) super.set(fieldName, value);
  }

  @Override
  public PortionSize clone() {
    return (PortionSize) super.clone();
  }

}
